var daemonize = require('daemonize');

var daemon = daemonize.setup({
	main: 'app.js',
	name: 'radar',
	pidfile: 'radar.pid'
});


switch (process.argv[2]) {
	case 'start':
		daemon.start().once('started', function() {
			process.exit();
		});
		break;
	case 'stop':
		daemon.stop();
		break;
	case 'kill':
		daemon.kill();
		break;
	case 'restart':
		if (daemon.status()) {
			daemon.stop().once('stopped', function() {
				daemon.start().once('started', function() {
					process.exit();
				});
			});
		} else {
			daemon.start().once('started', function() {
				process.exit();
			});
		}
		break;
	case 'reload':
		console.log('Reload.');
		daemon.sendSignal('SIGUSR1');
		break;
	case 'status':
		var pid = daemon.status();
		if (pid) {
			console.log('Daemon running. PID: ' + pid);
		} else {
			console.log('Daemon is not running.');
		}
    break;
	default:
		console.log('Usage: [start|stop|kill|restart|reload|status]');
}