// Require in modules
var express = require('express');
var stylus = require('stylus');

var port = 8083;
var app = express.createServer();

// Configure express
app.configure(function(){
	app.use(express.bodyParser());
	app.use(express.cookieParser());
	app.use(express.methodOverride());

	// Stylus (compiled css).
	app.use(stylus.middleware({
		src: __dirname + '/views',
		dest: __dirname + '/public',
	}));

	app.use(app.router);
	app.use(express.static(__dirname + '/public'));

	// Default to EJS templates.
	app.set('views', __dirname + '/views');
	app.set('view engine', 'ejs');
});

// Routes
app.get('/', function index(req, res) {
	var properties = [];
	res.render('index', {
		title: 'Visual Rent',
		properties: properties
	});
});

app.listen(port);
console.log('Express web server started on port ' + port);