// Require in modules
var scraper = require('scraper');
var mongolian = require('mongolian');

// Configure script variables
var baseUrl = 'http://www.realestate.com.au';

// Mongo
var server = new mongolian();
var db = server.db('visual_rent');
var collection = db.collection('properties');

// User defined vars
var minPrice = 300;
var maxPrice = 400;
var suburb = 'Camberwell';
var postcode = '3124';

var listUrl = baseUrl + '/rent/between-' + minPrice + '-' + maxPrice + '-in-' + suburb + '+' + postcode + '/list-1';

console.log('Starting scraping');
scraper(listUrl, function(err, $) {
	if (err) { throw err; }
	console.log('Finished scraping');

	var properties = [];

	// For each property in result list, get its detail page url
	$('.resultBodyWrapper .vcard h2 a').each(function() {
		var property = {
			href: $(this).attr('href')
		};
		properties.push(property);
	});

	// For each property, visit its detail page and get all the image urls
	properties.forEach(function(property) {
		scraper(baseUrl + property.href, function(err, $) {
			if (err) { throw err; }

			property.images = [];
			$('#primaryContent .thumbs .thumb img').each(function() {
				var src = $(this).attr('src');
				var large = src.replace('120x90','456x342');
				property.images.push(large);
			});

			console.log('Inserting property: ', property.href);
			collection.insert(property);
		});
	});
});