// Require in modules
var youtube = require('youtube-dl');

// Get command line args
var args = process.argv.slice(2); // slice off 1st 2 items
var videoId = args[0] || 'QH2-TGUlwu4';
var output = args[1] || '/Users/ben/Desktop';

// Construct script variables
var path = 'http://www.youtube.com/watch?v=' + videoId;

// Get video clip information
youtube.info(path, function(err, info) {
	if (err) { throw err; }
	console.log(info);
});

// Begin downloading video clip
var download = youtube.download(path, output);

// On download starting
download.on('download', function(data) {
  console.log('Download started');
  console.log('filename: ' + data.filename);
  console.log('size: ' + data.size);
});

// As download progresses
download.on('progress', function(data) {
	process.stdout.write(data.eta + ' ' + data.percent + '% at ' + data.speed + '\r');
});

// Catches any errors
download.on('error', function(err) {
	throw err;
});

// On download finishing
download.on('end', function(data) {
	console.log('\nDownload finished!');
	console.log('Filename: ' + data.filename);
	console.log('Size: ' + data.size);
	console.log('Time Taken: ' + data.timeTaken);
	console.log('Time Taken in ms: ' + data.timeTakenms);
	console.log('Average Speed: ' + data.averageSpeed);
	console.log('Average Speed in Bytes: ' + data.averageSpeedBytes);
});
